org.bouncycastle.crypto

## Interface BlockCipher

All Known Implementing Classes:
  AESEngine, AESFastEngine, AESLightEngine, BlowfishEngine, CamelliaEngine, CamelliaLightEngine, CAST5Engine, CAST6Engine, CBCBlockCipher, CFBBlockCipher, DESedeEngine, DESEngine, GOFBBlockCipher, GOST28147Engine, IDEAEngine, NoekeonEngine, NullEngine, OFBBlockCipher, OpenPGPCFBBlockCipher, PGPCFBBlockCipher, RC2Engine, RC532Engine, RC564Engine, RC6Engine, RijndaelEngine, SEEDEngine, SerpentEngine, SICBlockCipher, SkipjackEngine, TEAEngine, TwofishEngine, XTEAEngine

    public interface BlockCipher

Block cipher engines are expected to conform to this interface.

### Method Summary

Methods
`java.lang.String` `getAlgorithmName()` Return the name of the algorithm the cipher implements.
`int` `getBlockSize()` Return the block size for this cipher (in bytes).
`void` `init(boolean forEncryption, CipherParameters params)` Initialise the cipher.
`int` `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
`void` `reset()` Reset the cipher.

### Method Detail

#### init

    void init(boolean forEncryption,
            CipherParameters params)
              throws java.lang.IllegalArgumentException

Initialise the cipher.

Parameters:
  `forEncryption` - if true the cipher is initialised for encryption, if false for decryption.
  `params` - the key and other data required by the cipher.
Throws:
  `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

#### getAlgorithmName

    java.lang.String getAlgorithmName()

Return the name of the algorithm the cipher implements.

Returns:
  the name of the algorithm the cipher implements.

#### getBlockSize

    int getBlockSize()

Return the block size for this cipher (in bytes).

Returns:
  the block size for this cipher in bytes.

#### processBlock

    int processBlock(byte[] in,
                   int inOff,
                   byte[] out,
                   int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

Process one block of input from the array in and write it to the out array.

Parameters:
  `in` - the array containing the input data.
  `inOff` - offset into the in array the data starts at.
  `out` - the array the output data will be copied into.
  `outOff` - the offset into the out array the output will start at.
Returns:
  the number of bytes processed and produced.
Throws:
  `DataLengthException` - if there isn't enough data in in, or space in out.
  `java.lang.IllegalStateException` - if the cipher isn't initialised.

#### reset

    void reset()

Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).